<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Under Water Drone: cuboid.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Under Water Drone
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',false,false,'search.php','Search');
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('cuboid_8cpp_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">cuboid.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="cuboid_8cpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="cuboid_8hh.html">cuboid.hh</a>&quot;</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160; </div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160; </div>
<div class="line"><a name="l00005"></a><span class="lineno"><a class="line" href="class_cuboid.html#a1abf60e93d024b7a01ee5b1a48f1f08a">    5</a></span>&#160;<a class="code" href="class_cuboid.html#a1abf60e93d024b7a01ee5b1a48f1f08a">Cuboid::Cuboid</a>() {</div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;    <span class="comment">// Open file with model coordinates of cuboid</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;    ifstream inputFile;</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;    inputFile.open(kModelCuboid_);</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;    <span class="comment">// Check if the file is open correctly</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;    <span class="keywordflow">if</span> (!inputFile.is_open()) {</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;        cerr &lt;&lt; <span class="stringliteral">&quot;Unable to load model Cuboid file!&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;        <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    }</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    <span class="comment">// Read all of model coordinates</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    <a class="code" href="class_vector.html">Vector3D</a> point;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    <span class="keywordflow">while</span> (inputFile &gt;&gt; point) {</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;        points_.push_back(point);</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        allCounter_++; <span class="comment">// Increase counter of total number of Vector3D objects</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        currentCounter_++; <span class="comment">// Increase counter of current number of Vector3D objects</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160; </div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        <span class="comment">// Read the enlarged drone body as a drone cover later used for collision checking</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;        cuboidCover_.push_back(point * 1.5);</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    }</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    inputFile.close();</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;}</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160; </div>
<div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="class_cuboid.html#ac05b065f9298c6577f8bf4af96ae08a2">   29</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="class_cuboid.html#ac05b065f9298c6577f8bf4af96ae08a2">Cuboid::draw</a>(<span class="keyword">const</span> std::string &amp;filename)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="comment">// Open file to which all coordinates will be saved</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    ofstream outputFile;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    outputFile.open(filename);</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160; </div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="comment">// Check if the file is open correctly</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keywordflow">if</span> (!outputFile.is_open()) {</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        cerr &lt;&lt; <span class="stringliteral">&quot;Unable to open drone file!&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    }</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160; </div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="comment">// Rotation matrix to rotate the drone in OZ axis</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <a class="code" href="class_rotation_matrix.html">RotationMatrix</a> matrix(angle_);</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160; </div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="comment">// Save all coordinates to the result file</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> i = 0; i &lt; points_.size(); ++i) {</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        outputFile &lt;&lt; (matrix * points_[i]) + translation_ &lt;&lt; endl;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        <span class="keywordflow">if</span> (i % 4 == 3) {</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;            outputFile &lt;&lt; <span class="stringliteral">&quot;#\n\n&quot;</span>;</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        }</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    }</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;}</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160; </div>
<div class="line"><a name="l00052"></a><span class="lineno"><a class="line" href="class_cuboid.html#a8e5ab60bcdf1e2a0571f1d38800543a4">   52</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="class_cuboid.html#a8e5ab60bcdf1e2a0571f1d38800543a4">Cuboid::translateCover</a>(<span class="keyword">const</span> <a class="code" href="class_vector.html">Vector3D</a> &amp;change) {</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="comment">// Translate all of drone cover coordinate with the same translation vector as drone body</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keywordflow">for</span> (<span class="keyword">auto</span> &amp;i : cuboidCover_) {</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        i = i + change;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    }</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160; </div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;}</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160; </div>
<div class="line"><a name="l00060"></a><span class="lineno"><a class="line" href="class_cuboid.html#a01ff3d2d1f5d2736d614bfe2adf695dd">   60</a></span>&#160;vector&lt;Vector3D&gt; <a class="code" href="class_cuboid.html#a01ff3d2d1f5d2736d614bfe2adf695dd">Cuboid::getNextStepCover</a>(<span class="keyword">const</span> <a class="code" href="class_vector.html">Vector3D</a> &amp;translation)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    vector&lt;Vector3D&gt; nextStepCover;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160; </div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="comment">// Reserve memory for drone cover in nest step of movement</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    nextStepCover.reserve(cuboidCover_.size());</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160; </div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keywordflow">for</span> (<span class="keyword">const</span> <span class="keyword">auto</span> &amp;i : cuboidCover_) {</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        nextStepCover.push_back(i + translation);</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    }</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160; </div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keywordflow">return</span> nextStepCover;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;}</div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="aclass_cuboid_html_a8e5ab60bcdf1e2a0571f1d38800543a4"><div class="ttname"><a href="class_cuboid.html#a8e5ab60bcdf1e2a0571f1d38800543a4">Cuboid::translateCover</a></div><div class="ttdeci">void translateCover(const Vector3D &amp;change)</div><div class="ttdoc">Translates the drone cover. Moves the drone cover the same translation vector as the drone body.</div><div class="ttdef"><b>Definition:</b> <a href="cuboid_8cpp_source.html#l00052">cuboid.cpp:52</a></div></div>
<div class="ttc" id="aclass_cuboid_html_ac05b065f9298c6577f8bf4af96ae08a2"><div class="ttname"><a href="class_cuboid.html#ac05b065f9298c6577f8bf4af96ae08a2">Cuboid::draw</a></div><div class="ttdeci">void draw(const std::string &amp;filename) const override</div><div class="ttdoc">Saves the bottom coordinates to a result file.</div><div class="ttdef"><b>Definition:</b> <a href="cuboid_8cpp_source.html#l00029">cuboid.cpp:29</a></div></div>
<div class="ttc" id="aclass_rotation_matrix_html"><div class="ttname"><a href="class_rotation_matrix.html">RotationMatrix</a></div><div class="ttdoc">Models the concept of the rotation matrix of geometric object.</div><div class="ttdef"><b>Definition:</b> <a href="rotation_matrix_8hh_source.html#l00009">rotationMatrix.hh:9</a></div></div>
<div class="ttc" id="acuboid_8hh_html"><div class="ttname"><a href="cuboid_8hh.html">cuboid.hh</a></div></div>
<div class="ttc" id="aclass_cuboid_html_a01ff3d2d1f5d2736d614bfe2adf695dd"><div class="ttname"><a href="class_cuboid.html#a01ff3d2d1f5d2736d614bfe2adf695dd">Cuboid::getNextStepCover</a></div><div class="ttdeci">std::vector&lt; Vector3D &gt; getNextStepCover(const Vector3D &amp;translation) const</div><div class="ttdoc">Calculate the coordinates of drone cover in next step of animation (movement)</div><div class="ttdef"><b>Definition:</b> <a href="cuboid_8cpp_source.html#l00060">cuboid.cpp:60</a></div></div>
<div class="ttc" id="aclass_vector_html"><div class="ttname"><a href="class_vector.html">Vector&lt; double, 3 &gt;</a></div></div>
<div class="ttc" id="aclass_cuboid_html_a1abf60e93d024b7a01ee5b1a48f1f08a"><div class="ttname"><a href="class_cuboid.html#a1abf60e93d024b7a01ee5b1a48f1f08a">Cuboid::Cuboid</a></div><div class="ttdeci">Cuboid()</div><div class="ttdoc">Constructor for Cuboid class.</div><div class="ttdef"><b>Definition:</b> <a href="cuboid_8cpp_source.html#l00005">cuboid.cpp:5</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_167790342fb55959539d550b874be046.html">project</a></li><li class="navelem"><a class="el" href="dir_f77a644fded742ea05ed17fa0fdf6fe1.html">src</a></li><li class="navelem"><a class="el" href="cuboid_8cpp.html">cuboid.cpp</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.17 </li>
  </ul>
</div>
</body>
</html>
